## DynaMix Performance Tests

*Using a copy of [picobench](https://github.com/iboB/picobench)*

The performance tests are not built as part of the main build because the mutation performance test requires an additional ~400k source file which is generated by a script and not part of the repo.

To build the performance tests, you need to manually execute `generate.rb` in `mutation_perf/` with a Ruby interpreter and then call cmake with ` -DDYNAMIX_BUILD_PERF=1`

### Some perf-test results

OS: Ubuntu 16.04
CPU: AMD FX X8 8150
Compiler: gcc 5.4.0
Compiler arguments: `-O3`

|   Name (baseline is *)   |   Dim   |  Total ms |  ns/op  |Baseline| Ops/second|
|--------------------------|---------|-----------|---------|--------|-----------|
|             virtual_noop |  200000 |     1.288 |       6 |  0.256 |155225270.7|
|          std_func_noop * |  200000 |     5.035 |      25 |      - | 39725820.3|
|                 msg_noop |  200000 |     3.118 |      15 |  0.619 | 64151747.1|
|           virtual_setter |  200000 |     1.540 |       7 |  0.254 |129892565.9|
|        std_func_setter * |  200000 |     6.070 |      30 |      - | 32951002.8|
|               msg_setter |  200000 |     4.509 |      22 |  0.743 | 44354926.3|
|     (multi) virtual_noop |  200000 |     5.326 |      26 |  0.282 | 37549680.6|
|  (multi) std_func_noop * |  200000 |    18.881 |      94 |      - | 10592822.0|
|         (multi) msg_noop |  200000 |     7.760 |      38 |  0.411 | 25774461.3|
|   (multi) virtual_setter |  200000 |     6.192 |      30 |  0.279 | 32298656.6|
|(multi) std_func_setter * |  200000 |    22.219 |     111 |      - |  9001301.1|
|       (multi) msg_setter |  200000 |     8.877 |      44 |  0.400 | 22529979.2|
|            msg_sum_out * |  200000 |     7.465 |      37 |      - | 26793058.5|
|           out_combinator |  200000 |     7.422 |      37 |  0.994 | 26947524.5|
|           ret_combinator |  200000 |     7.434 |      37 |  0.996 | 26902627.8|
|          create_mutate * |   10000 |     9.810 |     981 |      - |  1019320.5|
|            type_template |   10000 |     3.728 |     372 |  0.380 |  2682686.2|
|      type_template_alloc |   10000 |     2.163 |     216 |  0.220 |  4623247.0|
|               mutation * |   10000 |     8.311 |     831 |      - |  1203170.2|
|        same_type_mutator |   10000 |     2.944 |     294 |  0.354 |  3397164.9|
|  same_type_mutator_alloc |   10000 |     1.336 |     133 |  0.161 |  7486296.3|


OS: Ubuntu 16.04
CPU: AMD FX X8 8150
Compiler: clang 4.0
Compiler arguments: `-O3`

|   Name (baseline is *)   |   Dim   |  Total ms |  ns/op  |Baseline| Ops/second|
|--------------------------|---------|-----------|---------|--------|-----------|
|             virtual_noop |  200000 |     1.374 |       6 |  0.262 |145523867.7|
|          std_func_noop * |  200000 |     5.250 |      26 |      - | 38095782.3|
|                 msg_noop |  200000 |     3.111 |      15 |  0.593 | 64295367.8|
|           virtual_setter |  200000 |     1.504 |       7 |  0.233 |133005519.1|
|        std_func_setter * |  200000 |     6.463 |      32 |      - | 30943676.9|
|               msg_setter |  200000 |     4.414 |      22 |  0.683 | 45312111.0|
|     (multi) virtual_noop |  200000 |     5.536 |      27 |  0.296 | 36128003.0|
|  (multi) std_func_noop * |  200000 |    18.725 |      93 |      - | 10680653.5|
|         (multi) msg_noop |  200000 |     4.961 |      24 |  0.265 | 40313883.9|
|   (multi) virtual_setter |  200000 |     6.427 |      32 |  0.287 | 31118030.4|
|(multi) std_func_setter * |  200000 |    22.410 |     112 |      - |  8924741.4|
|       (multi) msg_setter |  200000 |     7.975 |      39 |  0.356 | 25078857.3|
|            msg_sum_out * |  200000 |     6.773 |      33 |      - | 29528388.8|
|           out_combinator |  200000 |     6.946 |      34 |  1.025 | 28794669.5|
|           ret_combinator |  200000 |     6.974 |      34 |  1.030 | 28679102.2|
|          create_mutate * |   10000 |     9.496 |     949 |      - |  1053100.7|
|            type_template |   10000 |     3.679 |     367 |  0.387 |  2718209.0|
|      type_template_alloc |   10000 |     2.160 |     216 |  0.227 |  4629348.9|
|               mutation * |   10000 |     7.999 |     799 |      - |  1250161.9|
|        same_type_mutator |   10000 |     2.948 |     294 |  0.369 |  3392561.8|
|  same_type_mutator_alloc |   10000 |     1.518 |     151 |  0.190 |  6588986.9|

OS: Windows 10
CPU: Intel Core i7 @ 2.3GHz
Compiler: Visual C++ 14 (2015) Update 3
Compiler arguments: `/O2 /Ob2 /MD`

|   Name (baseline is *)   |   Dim   |  Total ms |  ns/op  |Baseline| Ops/second|
|--------------------------|---------|-----------|---------|--------|-----------|
|             virtual_noop |  200000 |     0.930 |       4 |  0.204 |215059082.1|
|          std_func_noop * |  200000 |     4.549 |      22 |      - | 43965397.5|
|                 msg_noop |  200000 |     2.841 |      14 |  0.625 | 70391577.8|
|           virtual_setter |  200000 |     1.212 |       6 |  0.146 |165015820.9|
|        std_func_setter * |  200000 |     8.302 |      41 |      - | 24089393.8|
|               msg_setter |  200000 |     4.561 |      22 |  0.549 | 43853542.3|
|     (multi) virtual_noop |  200000 |     4.115 |      20 |  0.331 | 48604622.1|
|  (multi) std_func_noop * |  200000 |    12.443 |      62 |      - | 16073708.9|
|         (multi) msg_noop |  200000 |     5.343 |      26 |  0.429 | 37429695.3|
|   (multi) virtual_setter |  200000 |     5.581 |      27 |  0.306 | 35837457.8|
|(multi) std_func_setter * |  200000 |    18.236 |      91 |      - | 10967410.0|
|       (multi) msg_setter |  200000 |     9.913 |      49 |  0.544 | 20175710.3|
|            msg_sum_out * |  200000 |     8.144 |      40 |      - | 24559328.9|
|           out_combinator |  200000 |     7.222 |      36 |  0.887 | 27691269.5|
|           ret_combinator |  200000 |     7.323 |      36 |  0.899 | 27309928.4|
|          create_mutate * |   10000 |    16.103 |    1610 |      - |   620993.2|
|            type_template |   10000 |     5.468 |     546 |  0.340 |  1828722.2|
|      type_template_alloc |   10000 |     2.749 |     274 |  0.171 |  3637850.5|
|               mutation * |   10000 |    10.333 |    1033 |      - |   967747.5|
|        same_type_mutator |   10000 |     3.648 |     364 |  0.353 |  2741181.5|
|  same_type_mutator_alloc |   10000 |     1.688 |     168 |  0.163 |  5923647.7|
